<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <title>JS Drum Kit</title>
    <link rel="stylesheet" href="style.css" />
  </head>
  <body>
    <!-- 키보드들을 keys 로 묶음 -->
    <div class="keys">
      <!-- data-key 는 사용자 정의 속성 -->
      <div data-key="65" class="key">
        <kbd>A</kbd>
        <span class="sound">clap</span>
      </div>
      <div data-key="83" class="key">
        <kbd>S</kbd>
        <span class="sound">hihat</span>
      </div>
      <div data-key="68" class="key">
        <kbd>D</kbd>
        <span class="sound">kick</span>
      </div>
      <div data-key="70" class="key">
        <kbd>F</kbd>
        <span class="sound">openhat</span>
      </div>
      <div data-key="71" class="key">
        <kbd>G</kbd>
        <span class="sound">boom</span>
      </div>
      <div data-key="72" class="key">
        <kbd>H</kbd>
        <span class="sound">ride</span>
      </div>
      <div data-key="74" class="key">
        <kbd>J</kbd>
        <span class="sound">snare</span>
      </div>
      <div data-key="75" class="key">
        <kbd>K</kbd>
        <span class="sound">tom</span>
      </div>
      <div data-key="76" class="key">
        <kbd>L</kbd>
        <span class="sound">tink</span>
      </div>
    </div>

    <audio data-key="65" src="sounds/clap.wav"></audio>
    <audio data-key="83" src="sounds/hihat.wav"></audio>
    <audio data-key="68" src="sounds/kick.wav"></audio>
    <audio data-key="70" src="sounds/openhat.wav"></audio>
    <audio data-key="71" src="sounds/boom.wav"></audio>
    <audio data-key="72" src="sounds/ride.wav"></audio>
    <audio data-key="74" src="sounds/snare.wav"></audio>
    <audio data-key="75" src="sounds/tom.wav"></audio>
    <audio data-key="76" src="sounds/tink.wav"></audio>

    <script>
      const audioTags = document.querySelectorAll("audio");
      const keysContainer = document.querySelector(".keys");
      const keyTags = keysContainer.querySelectorAll("div");

      function playSound(e) {
        Array.prototype.forEach.call(audioTags, function (audioTag) {
          // 모든 audio 태그들의 data-key 값과 e.keyCode 비교함
          // window.addEventListener 의 keydown 에서 받음
          if (audioTag.getAttribute("data-key") == e.keyCode) {
            // 해당 오디오의 시작시간을 0으로 해서, 처음부터 들리도록 함
            audioTag.currentTime = 0;
            audioTag.play();
          }
        });

        Array.prototype.forEach.call(keyTags, function (keyTag) {
          if (keyTag.getAttribute("data-key") == e.keyCode) {
            // 눌리는 효과를 주기위함
            // playing 태그가 추가되면, 이 안에 transform 이 존재(방아쇠 역할)
            // 원래 key 태그 안에는 transition 이 존재하여
            // transform 에 대한 부가적인 속성을 부여해줌
            // 여기서는 천천히 transform 하도록 해줌
            keyTag.classList.add("playing");
          }
        });
      }

      function removeTransition(event) {
        // event.target 을 통해, 구체적으로 어떤 녀석인지 찾아냄
        // playing 을 제거하므로, 동일하게 transition 효과에 따라
        // scale 1 로 천천히 줄어듬
        event.target.classList.remove("playing");
      }

      window.addEventListener("keydown", playSound);

      // 이벤트 버블링을 통해, 감싸고 있는 keys 가 감지
      // transition 이 끝남을 감지
      keysContainer.addEventListener("transitionend", removeTransition);
    </script>
  </body>
</html>
